
package de.ivu.elect.presentation.benutzerverwaltung.menu;

import java.util.Collections;
import java.util.List;

import javax.inject.Inject;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.benutzerverwaltung.boundary.NachrichtConversationStore;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.benutzerverwaltung.NachrichtCreateView;

public class NachrichtCreateMenuItemEntry extends AbstractNachrichtMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  @ConversationGroup(NachrichtConversationStore.class)
  private NachrichtConversationStore nachrichtConversationStore;

  public NachrichtCreateMenuItemEntry() {
    super();
  }

  @Override
  protected UseCasePermission getUseCasePermission() {
    return UseCasePermission.NACHRICHT_CREATE;
  }

  @Override
  public String getTargetViewId() {
    return null; // doAction ausführen
  }

  @Override
  public String doAction() {
    // Cf. de.ivu.elect.presentation.benutzerverwaltung.action.NachrichtReplyAction.
    nachrichtConversationStore.setEntityPK(null);

    return NachrichtCreateView.VIEW_ID;
  }

  @Override
  protected List<String> getAdditionalTopicViewIds() {
    return Collections.singletonList(NachrichtCreateView.VIEW_ID);
  }


  @Override
  protected String getLabel() {
    return getMessage(getLabelKey(), getMeta().getEinzahlMessage());
  }

  @Override
  public String getLabelKey() {
    return "entity.create.menu.item.label";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconCreate();
  }
}
